<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>AMC13: /work/dan/AMC13/amc13-fw/src/common/DDR/ddr3_1_9_a/phy/mig_7series_v1_9_ddr_byte_group_io.v Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">AMC13
   </div>
   <div id="projectbrief">Firmwares for the different applications of the AMC13 uTCA board made at Boston University</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_fdedb0aba14d44ce9d99bc100e026e6a.html">common</a></li><li class="navelem"><a class="el" href="dir_04ba79c0d2c6a91c409d61692b0edfbc.html">DDR</a></li><li class="navelem"><a class="el" href="dir_112db334f7b2cba50b4af5e23d3bedae.html">ddr3_1_9_a</a></li><li class="navelem"><a class="el" href="dir_5021c4576ddf93df951f59ea3105484b.html">phy</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">mig_7series_v1_9_ddr_byte_group_io.v</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; <span class="keyword">/*****************************************************************</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="keyword">-- (c) Copyright 2011 - 2013 Xilinx, Inc. All rights reserved.</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">--</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">-- This file contains confidential and proprietary information</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">-- of Xilinx, Inc. and is protected under U.S. and</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">-- international copyright and other intellectual property</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">-- laws.</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">--</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">-- DISCLAIMER</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">-- This disclaimer is not a license and does not grant any</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">-- rights to the materials distributed herewith. Except as</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="keyword">-- otherwise provided in a valid license issued to you by</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="keyword">-- Xilinx, and to the maximum extent permitted by applicable</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">-- law: (1) THESE MATERIALS ARE MADE AVAILABLE &quot;AS IS&quot; AND</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="keyword">-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">-- (2) Xilinx shall not be liable (whether in contract or tort,</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">-- including negligence, or under any other theory of</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">-- liability) for any loss or damage of any kind or nature</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">-- related to, arising under or in connection with these</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">-- materials, including for any direct, or any indirect,</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">-- special, incidental, or consequential loss or damage</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">-- (including loss of data, profits, goodwill, or any type of</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">-- loss or damage suffered as a result of any action brought</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">-- by a third party) even if such damage or loss was</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">-- reasonably foreseeable or Xilinx had been advised of the</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">-- possibility of the same.</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">--</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">-- CRITICAL APPLICATIONS</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">-- Xilinx products are not designed or intended to be fail-</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">-- safe, or for use in any application requiring fail-safe</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">-- performance, such as life-support or safety devices or</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keyword">-- systems, Class III medical devices, nuclear facilities,</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">-- applications related to the deployment of airbags, or any</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">-- other applications that could lead to death, personal</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">-- injury, or severe property or environmental damage</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">-- (individually and collectively, &quot;Critical</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">-- Applications&quot;). A Customer assumes the sole risk and</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="keyword">-- liability of any use of Xilinx products in Critical</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keyword">-- Applications, subject only to applicable laws and</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">-- regulations governing limitations on product liability.</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="keyword">--</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="keyword">-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keyword">-- PART OF THIS FILE AT ALL TIMES.</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="keyword">//</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="keyword">//</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="keyword">//  Owner:        Gary Martin</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">//  Revision:     $Id: //depot/icm/proj/common/head/rtl/v32_cmt/rtl/phy/byte_group_io.v#4 $</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">//                $Author: $</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="keyword">//                $DateTime: $</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="keyword">//                $Change: $</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="keyword">//  Description:</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="keyword">//    This verilog file is a paramertizable I/O termination for </span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">//    the single byte lane. </span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">//    to create a N byte-lane wide phy. </span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="keyword">//</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="keyword">//  History:</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">//  Date        Engineer    Description</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keyword">//  04/01/2010  G. Martin   Initial Checkin.</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="keyword">//</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="keyword">//////////////////////////////////////////////////////////////////</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="keyword">******************************************************************/</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="preprocessor">`timescale</span> 1ps/1ps</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div>
<div class="line"><a name="l00069"></a><span class="lineno"><a class="code" href="enummig__7series__v1__9__ddr__byte__group__io.html">   69</a></span>&#160;<span class="vhdlkeyword">module</span> <a class="code" href="enummig__7series__v1__9__ddr__byte__group__io.html">mig_7series_v1_9_ddr_byte_group_io</a> #(</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="keyword">// bit lane existance</span></div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="vhdlkeyword">parameter</span>  <span class="vhdlchar">BITLANES</span>                      =  <span class="vhdllogic">12&#39;b1111_1111_1111</span>,</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="vhdlkeyword">parameter</span>  <span class="vhdlchar">BITLANES_OUTONLY</span>              =  <span class="vhdllogic">12&#39;b0000_0000_0000</span>,</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="vhdlkeyword">parameter</span>  <span class="vhdlchar">PO_DATA_CTL</span>                   = <span class="keyword">&quot;FALSE&quot;</span>,</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="vhdlkeyword">parameter</span>  <span class="vhdlchar">OSERDES_DATA_RATE</span>             = <span class="keyword">&quot;DDR&quot;</span>,</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="vhdlkeyword">parameter</span>  <span class="vhdlchar">OSERDES_DATA_WIDTH</span>            = <span class="vhdllogic">4</span>,</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="vhdlkeyword">parameter</span>  <span class="vhdlchar">IDELAYE2_IDELAY_TYPE</span>          = <span class="keyword">&quot;VARIABLE&quot;</span>,</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="vhdlkeyword">parameter</span>  <span class="vhdlchar">IDELAYE2_IDELAY_VALUE</span>         = <span class="vhdllogic">00</span>,</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="vhdlkeyword">parameter</span>  <span class="vhdlchar">IODELAY_GRP</span>                   = <span class="keyword">&quot;IODELAY_MIG&quot;</span>,</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="keyword">// local usage only, don&#39;t pass down</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="vhdlkeyword">parameter</span>  <span class="vhdlchar">BUS_WIDTH</span>                     = <span class="vhdllogic">12</span>,</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="vhdlkeyword">parameter</span>  <span class="vhdlchar">SYNTHESIS</span>                     = <span class="keyword">&quot;FALSE&quot;</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;   )</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;   (</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;   <span class="vhdlkeyword">input</span>  [<span class="vhdllogic">9</span>:<span class="vhdllogic">0</span>]                    <span class="vhdlchar">mem_dq_in</span>,</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;   <span class="vhdlkeyword">output</span> [<span class="vhdlchar">BUS_WIDTH</span>-<span class="vhdllogic">1</span>:<span class="vhdllogic">0</span>]          <span class="vhdlchar">mem_dq_out</span>,</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;   <span class="vhdlkeyword">output</span> [<span class="vhdlchar">BUS_WIDTH</span>-<span class="vhdllogic">1</span>:<span class="vhdllogic">0</span>]          <span class="vhdlchar">mem_dq_ts</span>,</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">mem_dqs_in</span>,</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;   <span class="vhdlkeyword">output</span>                          <span class="vhdlchar">mem_dqs_out</span>,</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;   <span class="vhdlkeyword">output</span>                          <span class="vhdlchar">mem_dqs_ts</span>,</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;   <span class="vhdlkeyword">output</span> [(<span class="vhdllogic">4</span>*<span class="vhdllogic">10</span>)-<span class="vhdllogic">1</span>:<span class="vhdllogic">0</span>]             <span class="vhdlchar">iserdes_dout</span>, <span class="keyword">// 2 extra 12-bit lanes not used</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;   <span class="vhdlkeyword">output</span>                          <span class="vhdlchar">dqs_to_phaser</span>,</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">iserdes_clk</span>,</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">iserdes_clkb</span>,</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">iserdes_clkdiv</span>,</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">phy_clk</span>,</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">rst</span>,</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">oserdes_rst</span>,</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">iserdes_rst</span>,</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;   <span class="vhdlkeyword">input</span> [<span class="vhdllogic">1</span>:<span class="vhdllogic">0</span>]                     <span class="vhdlchar">oserdes_dqs</span>,</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;   <span class="vhdlkeyword">input</span> [<span class="vhdllogic">1</span>:<span class="vhdllogic">0</span>]                     <span class="vhdlchar">oserdes_dqsts</span>,</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;   <span class="vhdlkeyword">input</span> [(<span class="vhdllogic">4</span>*<span class="vhdlchar">BUS_WIDTH</span>)-<span class="vhdllogic">1</span>:<span class="vhdllogic">0</span>]       <span class="vhdlchar">oserdes_dq</span>,</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;   <span class="vhdlkeyword">input</span> [<span class="vhdllogic">1</span>:<span class="vhdllogic">0</span>]                     <span class="vhdlchar">oserdes_dqts</span>,</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">oserdes_clk</span>,</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">oserdes_clk_delayed</span>,</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">oserdes_clkdiv</span>,</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">idelay_inc</span>,</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">idelay_ce</span>,</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">idelay_ld</span>,</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;   <span class="vhdlkeyword">input</span>                           <span class="vhdlchar">idelayctrl_refclk</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;   );</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="keyword">/// INSTANCES</span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_DATA_RATE</span>          = <span class="keyword">&quot;DDR&quot;</span>;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_DATA_WIDTH</span>         = <span class="vhdllogic">4</span>;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_DYN_CLKDIV_INV_EN</span>  = <span class="keyword">&quot;FALSE&quot;</span>;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_DYN_CLK_INV_EN</span>     = <span class="keyword">&quot;FALSE&quot;</span>;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_INIT_Q1</span>            = <span class="vhdllogic">1&#39;b0</span>;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_INIT_Q2</span>            = <span class="vhdllogic">1&#39;b0</span>;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_INIT_Q3</span>            = <span class="vhdllogic">1&#39;b0</span>;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_INIT_Q4</span>            = <span class="vhdllogic">1&#39;b0</span>;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_INTERFACE_TYPE</span>     = <span class="keyword">&quot;MEMORY_DDR3&quot;</span>;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_NUM_CE</span>                = <span class="vhdllogic">2</span>;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_IOBDELAY</span>           = <span class="keyword">&quot;IFD&quot;</span>;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_OFB_USED</span>           = <span class="keyword">&quot;FALSE&quot;</span>;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_SERDES_MODE</span>        = <span class="keyword">&quot;MASTER&quot;</span>;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_SRVAL_Q1</span>           = <span class="vhdllogic">1&#39;b0</span>;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_SRVAL_Q2</span>           = <span class="vhdllogic">1&#39;b0</span>;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_SRVAL_Q3</span>           = <span class="vhdllogic">1&#39;b0</span>;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="vhdlkeyword">localparam</span>    <span class="vhdlchar">ISERDES_DQ_SRVAL_Q4</span>           = <span class="vhdllogic">1&#39;b0</span>;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="vhdlkeyword">wire</span> [<span class="vhdlchar">BUS_WIDTH</span>-<span class="vhdllogic">1</span>:<span class="vhdllogic">0</span>]                    <span class="vhdlchar">data_in_dly</span>;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;<span class="vhdlkeyword">wire</span> [<span class="vhdlchar">BUS_WIDTH</span>-<span class="vhdllogic">1</span>:<span class="vhdllogic">0</span>]                    <span class="vhdlchar">oserdes_dq_buf</span>;</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="vhdlkeyword">wire</span> [<span class="vhdlchar">BUS_WIDTH</span>-<span class="vhdllogic">1</span>:<span class="vhdllogic">0</span>]                    <span class="vhdlchar">oserdes_dqts_buf</span>;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;<span class="vhdlkeyword">wire</span>                                    <span class="vhdlchar">oserdes_dqs_buf</span>;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="vhdlkeyword">wire</span>                                    <span class="vhdlchar">oserdes_dqsts_buf</span>;</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="vhdlkeyword">wire</span> [<span class="vhdllogic">9</span>:<span class="vhdllogic">0</span>]                              <span class="vhdlchar">data_in</span>;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="vhdlkeyword">wire</span>                                    <span class="vhdlchar">tbyte_out</span>;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="vhdlkeyword">assign</span> <span class="vhdlchar">mem_dq_out</span>  = <span class="vhdlchar">oserdes_dq_buf</span>;</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="vhdlkeyword">assign</span> <span class="vhdlchar">mem_dq_ts</span>   = <span class="vhdlchar">oserdes_dqts_buf</span>;</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="vhdlkeyword">assign</span> <span class="vhdlchar">data_in</span> = <span class="vhdlchar">mem_dq_in</span>;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="vhdlkeyword">assign</span> <span class="vhdlchar">mem_dqs_out</span> = <span class="vhdlchar">oserdes_dqs_buf</span>;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="vhdlkeyword">assign</span> <span class="vhdlchar">mem_dqs_ts</span>  = <span class="vhdlchar">oserdes_dqsts_buf</span>;</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="vhdlkeyword">assign</span> <span class="vhdlchar">dqs_to_phaser</span> = <span class="vhdlchar">mem_dqs_in</span>;</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="vhdlkeyword">reg</span> <span class="vhdlchar">iserdes_clk_d</span>;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;<span class="vhdlkeyword">always</span> @(*) </div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;   <span class="vhdlchar">iserdes_clk_d</span> &lt;= #(<span class="vhdllogic">025</span>)  <span class="vhdlchar">iserdes_clk</span>;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="vhdlkeyword">reg</span>  <span class="vhdlchar">idelay_ld_rst</span>;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="vhdlkeyword">reg</span>  <span class="vhdlchar">rst_r1</span>;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;<span class="vhdlkeyword">reg</span>  <span class="vhdlchar">rst_r2</span>;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="vhdlkeyword">reg</span>  <span class="vhdlchar">rst_r3</span>;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="vhdlkeyword">reg</span>  <span class="vhdlchar">rst_r4</span>;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="vhdlkeyword">always</span> @(<span class="vhdlkeyword">posedge</span> <span class="vhdlchar">phy_clk</span>) <span class="vhdlkeyword">begin</span></div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;  <span class="vhdlchar">rst_r1</span> &lt;= #<span class="vhdllogic">1</span> <span class="vhdlchar">rst</span>;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;  <span class="vhdlchar">rst_r2</span> &lt;= #<span class="vhdllogic">1</span> <span class="vhdlchar">rst_r1</span>;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;  <span class="vhdlchar">rst_r3</span> &lt;= #<span class="vhdllogic">1</span> <span class="vhdlchar">rst_r2</span>;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;  <span class="vhdlchar">rst_r4</span> &lt;= #<span class="vhdllogic">1</span> <span class="vhdlchar">rst_r3</span>;</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;<span class="vhdlkeyword">end</span></div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="vhdlkeyword">always</span> @(<span class="vhdlkeyword">posedge</span> <span class="vhdlchar">phy_clk</span>) <span class="vhdlkeyword">begin</span></div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;  <span class="vhdlkeyword">if</span> (<span class="vhdlchar">rst</span>)</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    <span class="vhdlchar">idelay_ld_rst</span> &lt;= #<span class="vhdllogic">1</span> <span class="vhdllogic">1&#39;b1</span>;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;  <span class="vhdlkeyword">else</span> <span class="vhdlkeyword">if</span> (<span class="vhdlchar">rst_r4</span>)</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="vhdlchar">idelay_ld_rst</span> &lt;= #<span class="vhdllogic">1</span> <span class="vhdllogic">1&#39;b0</span>;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="vhdlkeyword">end</span>    </div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="vhdlkeyword">genvar</span> <span class="vhdlchar">i</span>;</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;<span class="vhdlkeyword">generate</span></div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;<span class="vhdlkeyword">for</span> ( <span class="vhdlchar">i</span> = <span class="vhdllogic">0</span>; <span class="vhdlchar">i</span> != <span class="vhdllogic">10</span> &amp;&amp; <span class="vhdlchar">PO_DATA_CTL</span> == <span class="keyword">&quot;TRUE&quot;</span> ; <span class="vhdlchar">i</span>=<span class="vhdlchar">i</span>+<span class="vhdllogic">1</span>) <span class="vhdlkeyword">begin</span> : <span class="vhdlchar">input_</span></div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;  <span class="vhdlkeyword">if</span> ( <span class="vhdlchar">BITLANES</span>[<span class="vhdlchar">i</span>] &amp;&amp; !<span class="vhdlchar">BITLANES_OUTONLY</span>[<span class="vhdlchar">i</span>]) <span class="vhdlkeyword">begin</span>  : <span class="vhdlchar">iserdes_dq_</span></div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;     <span class="vhdlchar">ISERDESE2</span> #(</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;         .<span class="vhdlchar">DATA_RATE</span>                  ( <span class="vhdlchar">ISERDES_DQ_DATA_RATE</span>),</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;         .<span class="vhdlchar">DATA_WIDTH</span>                 ( <span class="vhdlchar">ISERDES_DQ_DATA_WIDTH</span>),</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;         .<span class="vhdlchar">DYN_CLKDIV_INV_EN</span>          ( <span class="vhdlchar">ISERDES_DQ_DYN_CLKDIV_INV_EN</span>),</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;         .<span class="vhdlchar">DYN_CLK_INV_EN</span>             ( <span class="vhdlchar">ISERDES_DQ_DYN_CLK_INV_EN</span>),</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;         .<span class="vhdlchar">INIT_Q1</span>                    ( <span class="vhdlchar">ISERDES_DQ_INIT_Q1</span>),</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;         .<span class="vhdlchar">INIT_Q2</span>                    ( <span class="vhdlchar">ISERDES_DQ_INIT_Q2</span>),</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;         .<span class="vhdlchar">INIT_Q3</span>                    ( <span class="vhdlchar">ISERDES_DQ_INIT_Q3</span>),</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;         .<span class="vhdlchar">INIT_Q4</span>                    ( <span class="vhdlchar">ISERDES_DQ_INIT_Q4</span>),</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;         .<span class="vhdlchar">INTERFACE_TYPE</span>             ( <span class="vhdlchar">ISERDES_DQ_INTERFACE_TYPE</span>),</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;         .<span class="vhdlchar">NUM_CE</span>                     ( <span class="vhdlchar">ISERDES_NUM_CE</span>),</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;         .<span class="vhdlchar">IOBDELAY</span>                   ( <span class="vhdlchar">ISERDES_DQ_IOBDELAY</span>),</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;         .<span class="vhdlchar">OFB_USED</span>                   ( <span class="vhdlchar">ISERDES_DQ_OFB_USED</span>),</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;         .<span class="vhdlchar">SERDES_MODE</span>                ( <span class="vhdlchar">ISERDES_DQ_SERDES_MODE</span>),</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;         .<span class="vhdlchar">SRVAL_Q1</span>                   ( <span class="vhdlchar">ISERDES_DQ_SRVAL_Q1</span>),</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;         .<span class="vhdlchar">SRVAL_Q2</span>                   ( <span class="vhdlchar">ISERDES_DQ_SRVAL_Q2</span>),</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;         .<span class="vhdlchar">SRVAL_Q3</span>                   ( <span class="vhdlchar">ISERDES_DQ_SRVAL_Q3</span>),</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;         .<span class="vhdlchar">SRVAL_Q4</span>                   ( <span class="vhdlchar">ISERDES_DQ_SRVAL_Q4</span>)</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;         )</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;         <span class="vhdlchar">iserdesdq</span></div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;         (</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;         .<span class="vhdlchar">O</span>                          (),</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;         .<span class="vhdlchar">Q1</span>                         (<span class="vhdlchar">iserdes_dout</span>[<span class="vhdllogic">4</span>*<span class="vhdlchar">i</span> + <span class="vhdllogic">3</span>]),</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;         .<span class="vhdlchar">Q2</span>                         (<span class="vhdlchar">iserdes_dout</span>[<span class="vhdllogic">4</span>*<span class="vhdlchar">i</span> + <span class="vhdllogic">2</span>]),</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;         .<span class="vhdlchar">Q3</span>                         (<span class="vhdlchar">iserdes_dout</span>[<span class="vhdllogic">4</span>*<span class="vhdlchar">i</span> + <span class="vhdllogic">1</span>]),</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;         .<span class="vhdlchar">Q4</span>                         (<span class="vhdlchar">iserdes_dout</span>[<span class="vhdllogic">4</span>*<span class="vhdlchar">i</span> + <span class="vhdllogic">0</span>]),</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;         .<span class="vhdlchar">Q5</span>                         (),</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;         .<span class="vhdlchar">Q6</span>                         (),</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;         .<span class="vhdlchar">SHIFTOUT1</span>                  (),</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;         .<span class="vhdlchar">SHIFTOUT2</span>                  (),</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;     </div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;         .<span class="vhdlchar">BITSLIP</span>                    (<span class="vhdllogic">1&#39;b0</span>),</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;         .<span class="vhdlchar">CE1</span>                        (<span class="vhdllogic">1&#39;b1</span>),</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;         .<span class="vhdlchar">CE2</span>                        (<span class="vhdllogic">1&#39;b1</span>),</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;         .<span class="vhdlchar">CLK</span>                        (<span class="vhdlchar">iserdes_clk_d</span>),</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;         .<span class="vhdlchar">CLKB</span>                       (!<span class="vhdlchar">iserdes_clk_d</span>),</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;         .<span class="vhdlchar">CLKDIVP</span>                    (<span class="vhdlchar">iserdes_clkdiv</span>),</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;         .<span class="vhdlchar">CLKDIV</span>                     (),</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;         .<span class="vhdlchar">DDLY</span>                       (<span class="vhdlchar">data_in_dly</span>[<span class="vhdlchar">i</span>]),</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;         .<span class="vhdlchar">D</span>                          (<span class="vhdlchar">data_in</span>[<span class="vhdlchar">i</span>]), <span class="keyword">// dedicated route to iob for debugging</span></div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;                                               <span class="keyword">// or as needed, select with IOBDELAY</span></div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;         .<span class="vhdlchar">DYNCLKDIVSEL</span>               (<span class="vhdllogic">1&#39;b0</span>),</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;         .<span class="vhdlchar">DYNCLKSEL</span>                  (<span class="vhdllogic">1&#39;b0</span>),</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;<span class="keyword">// NOTE: OCLK is not used in this design, but is required to meet </span></div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;<span class="keyword">// a design rule check in map and bitgen. Do not disconnect it.</span></div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;         .<span class="vhdlchar">OCLK</span>                       (<span class="vhdlchar">oserdes_clk</span>),</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;         .<span class="vhdlchar">OFB</span>                        (),</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;         .<span class="vhdlchar">RST</span>                        (<span class="vhdllogic">1&#39;b0</span>),</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;<span class="keyword">//         .RST                        (iserdes_rst),</span></div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;         .<span class="vhdlchar">SHIFTIN1</span>                   (<span class="vhdllogic">1&#39;b0</span>),</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;         .<span class="vhdlchar">SHIFTIN2</span>                   (<span class="vhdllogic">1&#39;b0</span>)</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;         );</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;<span class="vhdlkeyword">localparam</span> IDELAYE2_CINVCTRL_SEL          = <span class="keyword">&quot;FALSE&quot;</span>;</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;<span class="vhdlkeyword">localparam</span> IDELAYE2_DELAY_SRC             = <span class="keyword">&quot;IDATAIN&quot;</span>;</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;<span class="vhdlkeyword">localparam</span> IDELAYE2_HIGH_PERFORMANCE_MODE = <span class="keyword">&quot;TRUE&quot;</span>;</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;<span class="vhdlkeyword">localparam</span> IDELAYE2_PIPE_SEL              = <span class="keyword">&quot;FALSE&quot;</span>;</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;<span class="vhdlkeyword">localparam</span> IDELAYE2_ODELAY_TYPE           = <span class="keyword">&quot;FIXED&quot;</span>;</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;<span class="vhdlkeyword">localparam</span> IDELAYE2_REFCLK_FREQUENCY      = <span class="vhdllogic">200.0</span>;</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;<span class="vhdlkeyword">localparam</span> IDELAYE2_SIGNAL_PATTERN        = <span class="keyword">&quot;DATA&quot;</span>;</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;(* IODELAY_GROUP = IODELAY_GRP *)</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;     IDELAYE2 #(</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;         .CINVCTRL_SEL             ( IDELAYE2_CINVCTRL_SEL),</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;         .DELAY_SRC                ( IDELAYE2_DELAY_SRC),</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;         .HIGH_PERFORMANCE_MODE    ( IDELAYE2_HIGH_PERFORMANCE_MODE),</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;         .IDELAY_TYPE              ( IDELAYE2_IDELAY_TYPE),</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;         .IDELAY_VALUE             ( IDELAYE2_IDELAY_VALUE),</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;         .PIPE_SEL                 ( IDELAYE2_PIPE_SEL),</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;         .REFCLK_FREQUENCY         ( IDELAYE2_REFCLK_FREQUENCY ),</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;         .SIGNAL_PATTERN           ( IDELAYE2_SIGNAL_PATTERN)</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;         )</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;         idelaye2</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;         (</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;         .CNTVALUEOUT              (),</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;         .DATAOUT                  (data_in_dly[i]),</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;         .C                        (phy_clk), <span class="keyword">// automatically wired by ISE</span></div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;         .CE                       (idelay_ce),</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;         .CINVCTRL                 (),</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;         .CNTVALUEIN               (<span class="vhdllogic">5&#39;b00000</span>), </div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;         .DATAIN                   (<span class="vhdllogic">1&#39;b0</span>),</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;         .IDATAIN                  (data_in[i]),</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;         .INC                      (idelay_inc),</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;         .LD                       (idelay_ld | idelay_ld_rst),</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;         .LDPIPEEN                 (<span class="vhdllogic">1&#39;b0</span>),</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;         .REGRST                   (rst) </div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;     );</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    <span class="vhdlkeyword">end</span> <span class="keyword">// iserdes_dq</span></div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    <span class="vhdlkeyword">else</span> <span class="vhdlkeyword">begin</span> </div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;        <span class="vhdlkeyword">assign</span> <span class="vhdlchar">iserdes_dout</span>[<span class="vhdllogic">4</span>*<span class="vhdlchar">i</span> + <span class="vhdllogic">3</span>] = <span class="vhdllogic">0</span>;</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;        <span class="vhdlkeyword">assign</span> <span class="vhdlchar">iserdes_dout</span>[<span class="vhdllogic">4</span>*<span class="vhdlchar">i</span> + <span class="vhdllogic">2</span>] = <span class="vhdllogic">0</span>;</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        <span class="vhdlkeyword">assign</span> <span class="vhdlchar">iserdes_dout</span>[<span class="vhdllogic">4</span>*<span class="vhdlchar">i</span> + <span class="vhdllogic">1</span>] = <span class="vhdllogic">0</span>;</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;        <span class="vhdlkeyword">assign</span> <span class="vhdlchar">iserdes_dout</span>[<span class="vhdllogic">4</span>*<span class="vhdlchar">i</span> + <span class="vhdllogic">0</span>] = <span class="vhdllogic">0</span>;</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    <span class="vhdlkeyword">end</span></div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;<span class="vhdlkeyword">end</span> <span class="keyword">// input_</span></div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;<span class="vhdlkeyword">endgenerate</span>         <span class="keyword">// iserdes_dq_</span></div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQ_DATA_RATE_OQ</span>    = <span class="vhdlchar">OSERDES_DATA_RATE</span>;</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQ_DATA_RATE_TQ</span>    = <span class="vhdlchar">OSERDES_DQ_DATA_RATE_OQ</span>;</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQ_DATA_WIDTH</span>      = <span class="vhdlchar">OSERDES_DATA_WIDTH</span>;</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQ_INIT_OQ</span>         = <span class="vhdllogic">1&#39;b1</span>;</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQ_INIT_TQ</span>         = <span class="vhdllogic">1&#39;b1</span>;</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQ_INTERFACE_TYPE</span>  = <span class="keyword">&quot;DEFAULT&quot;</span>;</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQ_ODELAY_USED</span>     = <span class="vhdllogic">0</span>;</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQ_SERDES_MODE</span>     = <span class="keyword">&quot;MASTER&quot;</span>;</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQ_SRVAL_OQ</span>        = <span class="vhdllogic">1&#39;b1</span>;</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQ_SRVAL_TQ</span>        = <span class="vhdllogic">1&#39;b1</span>;</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;<span class="keyword">// note: obuf used in control path case, no ts input so width irrelevant</span></div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQ_TRISTATE_WIDTH</span>  = (<span class="vhdlchar">OSERDES_DQ_DATA_RATE_OQ</span> == <span class="keyword">&quot;DDR&quot;</span>) ? <span class="vhdllogic">4</span> : <span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQS_DATA_RATE_OQ</span>   = <span class="keyword">&quot;DDR&quot;</span>;</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQS_DATA_RATE_TQ</span>   = <span class="keyword">&quot;DDR&quot;</span>;</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQS_TRISTATE_WIDTH</span> = <span class="vhdllogic">4</span>;  <span class="keyword">// this is always ddr</span></div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_DQS_DATA_WIDTH</span>     = <span class="vhdllogic">4</span>;</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">ODDR_CLK_EDGE</span>              = <span class="keyword">&quot;SAME_EDGE&quot;</span>;</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;<span class="vhdlkeyword">localparam</span> <span class="vhdlchar">OSERDES_TBYTE_CTL</span>          = <span class="keyword">&quot;TRUE&quot;</span>;</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;<span class="vhdlkeyword">generate</span> </div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;<span class="vhdlkeyword">localparam</span> NUM_BITLANES = <span class="vhdlchar">PO_DATA_CTL</span> == <span class="keyword">&quot;TRUE&quot;</span> ? <span class="vhdllogic">10</span> : BUS_WIDTH;</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;     <span class="vhdlkeyword">if</span> ( PO_DATA_CTL == <span class="keyword">&quot;TRUE&quot;</span> ) <span class="vhdlkeyword">begin</span>  : slave_ts</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;           OSERDESE2 #(</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;               .DATA_RATE_OQ         (OSERDES_DQ_DATA_RATE_OQ),</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;               .DATA_RATE_TQ         (OSERDES_DQ_DATA_RATE_TQ),</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;               .DATA_WIDTH           (OSERDES_DQ_DATA_WIDTH),</div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;               .INIT_OQ              (OSERDES_DQ_INIT_OQ),</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;               .INIT_TQ              (OSERDES_DQ_INIT_TQ),</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;               .SERDES_MODE          (OSERDES_DQ_SERDES_MODE),</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;               .SRVAL_OQ             (OSERDES_DQ_SRVAL_OQ),</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;               .SRVAL_TQ             (OSERDES_DQ_SRVAL_TQ),</div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;               .TRISTATE_WIDTH       (OSERDES_DQ_TRISTATE_WIDTH),</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;               .TBYTE_CTL            (<span class="keyword">&quot;TRUE&quot;</span>),</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;               .TBYTE_SRC            (<span class="keyword">&quot;TRUE&quot;</span>)</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;            )</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;            oserdes_slave_ts</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;            (</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;                .OFB                 (),</div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;                .OQ                  (),</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;                .SHIFTOUT1           (),    <span class="keyword">// not extended</span></div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;                .SHIFTOUT2           (),    <span class="keyword">// not extended</span></div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;                .TFB                 (),</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;                .TQ                  (),</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;                .CLK                 (oserdes_clk),</div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;                .CLKDIV              (oserdes_clkdiv),</div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;                .D1                  (),</div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;                .D2                  (),</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;                .D3                  (),</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;                .D4                  (),</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;                .D5                  (),</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;                .D6                  (),</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;               .OCE                  (<span class="vhdllogic">1&#39;b1</span>),</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;               .RST                  (oserdes_rst),</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;               .SHIFTIN1             (),     <span class="keyword">// not extended</span></div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;               .SHIFTIN2             (),     <span class="keyword">// not extended</span></div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;               .T1                   (oserdes_dqts[<span class="vhdllogic">0</span>]),</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;               .T2                   (oserdes_dqts[<span class="vhdllogic">0</span>]),</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;               .T3                   (oserdes_dqts[<span class="vhdllogic">1</span>]),</div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;               .T4                   (oserdes_dqts[<span class="vhdllogic">1</span>]),</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;               .TCE                  (<span class="vhdllogic">1&#39;b1</span>),</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;               .TBYTEOUT             (tbyte_out),</div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;               .TBYTEIN              (tbyte_out)</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;             );</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;     <span class="vhdlkeyword">end</span> <span class="keyword">// slave_ts</span></div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;  <span class="vhdlkeyword">for</span> (i = <span class="vhdllogic">0</span>; i != NUM_BITLANES; i=i+<span class="vhdllogic">1</span>) <span class="vhdlkeyword">begin</span> : output_</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;     <span class="vhdlkeyword">if</span> ( BITLANES[i]) <span class="vhdlkeyword">begin</span>  : oserdes_dq_</div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;        <span class="vhdlkeyword">if</span> ( PO_DATA_CTL == <span class="keyword">&quot;TRUE&quot;</span> ) <span class="vhdlkeyword">begin</span>  : ddr</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;           OSERDESE2 #(</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;               .DATA_RATE_OQ         (OSERDES_DQ_DATA_RATE_OQ),</div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;               .DATA_RATE_TQ         (OSERDES_DQ_DATA_RATE_TQ),</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;               .DATA_WIDTH           (OSERDES_DQ_DATA_WIDTH),</div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;               .INIT_OQ              (OSERDES_DQ_INIT_OQ),</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;               .INIT_TQ              (OSERDES_DQ_INIT_TQ),</div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;               .SERDES_MODE          (OSERDES_DQ_SERDES_MODE),</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;               .SRVAL_OQ             (OSERDES_DQ_SRVAL_OQ),</div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;               .SRVAL_TQ             (OSERDES_DQ_SRVAL_TQ),</div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;               .TRISTATE_WIDTH       (OSERDES_DQ_TRISTATE_WIDTH),</div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;               .TBYTE_CTL            (OSERDES_TBYTE_CTL),</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;               .TBYTE_SRC            (<span class="keyword">&quot;FALSE&quot;</span>)</div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;             )</div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;              oserdes_dq_i </div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;              (</div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;                .OFB               (),</div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;                .OQ                (oserdes_dq_buf[i]),</div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;                .SHIFTOUT1         (),  <span class="keyword">// not extended</span></div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;                .SHIFTOUT2         (),  <span class="keyword">// not extended</span></div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;                .TFB               (),</div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;                .TQ                (oserdes_dqts_buf[i]),</div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;                .CLK               (oserdes_clk),</div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;                .CLKDIV            (oserdes_clkdiv),</div>
<div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;                .D1                (oserdes_dq[<span class="vhdllogic">4</span> * i + <span class="vhdllogic">0</span>]),</div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;                .D2                (oserdes_dq[<span class="vhdllogic">4</span> * i + <span class="vhdllogic">1</span>]),</div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;                .D3                (oserdes_dq[<span class="vhdllogic">4</span> * i + <span class="vhdllogic">2</span>]),</div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;                .D4                (oserdes_dq[<span class="vhdllogic">4</span> * i + <span class="vhdllogic">3</span>]),</div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;                .D5                (),</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;                .D6                (),</div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;               .OCE                (<span class="vhdllogic">1&#39;b1</span>),</div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;               .RST                (oserdes_rst),</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;               .SHIFTIN1           (),     <span class="keyword">// not extended</span></div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;               .SHIFTIN2           (),     <span class="keyword">// not extended</span></div>
<div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;               .T1                 (<span class="keyword">/*oserdes_dqts[0]**/</span>),</div>
<div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;               .T2                 (<span class="keyword">/*oserdes_dqts[0]**/</span>),</div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;               .T3                 (<span class="keyword">/*oserdes_dqts[1]**/</span>),</div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;               .T4                 (<span class="keyword">/*oserdes_dqts[1]**/</span>),</div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;               .TCE                (<span class="vhdllogic">1&#39;b1</span>),</div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;               .TBYTEIN            (tbyte_out)</div>
<div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;              );</div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;           <span class="vhdlkeyword">end</span></div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;           <span class="vhdlkeyword">else</span> <span class="vhdlkeyword">begin</span> :  sdr </div>
<div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;           OSERDESE2 #(</div>
<div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;               .DATA_RATE_OQ         (OSERDES_DQ_DATA_RATE_OQ),</div>
<div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;               .DATA_RATE_TQ         (OSERDES_DQ_DATA_RATE_TQ),</div>
<div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;               .DATA_WIDTH           (OSERDES_DQ_DATA_WIDTH),</div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;               .INIT_OQ              (<span class="vhdllogic">1&#39;b0</span> <span class="keyword">/*OSERDES_DQ_INIT_OQ**/</span>),</div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;               .INIT_TQ              (OSERDES_DQ_INIT_TQ),</div>
<div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;               .SERDES_MODE          (OSERDES_DQ_SERDES_MODE),</div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;               .SRVAL_OQ             (<span class="vhdllogic">1&#39;b0</span> <span class="keyword">/*OSERDES_DQ_SRVAL_OQ**/</span>),</div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;               .SRVAL_TQ             (OSERDES_DQ_SRVAL_TQ),</div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;               .TRISTATE_WIDTH       (OSERDES_DQ_TRISTATE_WIDTH) </div>
<div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;              )</div>
<div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;              oserdes_dq_i </div>
<div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;              (</div>
<div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;                .OFB               (),</div>
<div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;                .OQ                (oserdes_dq_buf[i]),</div>
<div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;                .SHIFTOUT1         (),  <span class="keyword">// not extended</span></div>
<div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;                .SHIFTOUT2         (),  <span class="keyword">// not extended</span></div>
<div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;                .TFB               (),</div>
<div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;                .TQ                (),</div>
<div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;                .CLK               (oserdes_clk),</div>
<div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;                .CLKDIV            (oserdes_clkdiv),</div>
<div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;                .D1                (oserdes_dq[<span class="vhdllogic">4</span> * i + <span class="vhdllogic">0</span>]),</div>
<div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;                .D2                (oserdes_dq[<span class="vhdllogic">4</span> * i + <span class="vhdllogic">1</span>]),</div>
<div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;                .D3                (oserdes_dq[<span class="vhdllogic">4</span> * i + <span class="vhdllogic">2</span>]),</div>
<div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;                .D4                (oserdes_dq[<span class="vhdllogic">4</span> * i + <span class="vhdllogic">3</span>]),</div>
<div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;                .D5                (),</div>
<div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;                .D6                (),</div>
<div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;               .OCE                (<span class="vhdllogic">1&#39;b1</span>),</div>
<div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;               .RST                (oserdes_rst),</div>
<div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;               .SHIFTIN1           (),     <span class="keyword">// not extended</span></div>
<div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;               .SHIFTIN2           (),     <span class="keyword">// not extended</span></div>
<div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;               .T1                 (),</div>
<div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;               .T2                 (),</div>
<div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;               .T3                 (),</div>
<div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;               .T4                 (),</div>
<div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;               .TCE                (<span class="vhdllogic">1&#39;b1</span>) </div>
<div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;              );</div>
<div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;           <span class="vhdlkeyword">end</span> <span class="keyword">// ddr</span></div>
<div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;     <span class="vhdlkeyword">end</span> <span class="keyword">// oserdes_dq_</span></div>
<div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;  <span class="vhdlkeyword">end</span> <span class="keyword">// output_</span></div>
<div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;  </div>
<div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;<span class="vhdlkeyword">endgenerate</span></div>
<div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;</div>
<div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;<span class="vhdlkeyword">generate</span></div>
<div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;</div>
<div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160; <span class="vhdlkeyword">if</span> ( PO_DATA_CTL == <span class="keyword">&quot;TRUE&quot;</span> )  <span class="vhdlkeyword">begin</span> : <span class="vhdlchar">dqs_gen</span></div>
<div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;</div>
<div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;   <span class="vhdlchar">ODDR</span>  </div>
<div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;      #(.<span class="vhdlchar">DDR_CLK_EDGE</span>  (<span class="vhdlchar">ODDR_CLK_EDGE</span>))</div>
<div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;      <span class="vhdlchar">oddr_dqs</span> </div>
<div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;   (</div>
<div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;       .<span class="vhdlchar">Q</span>   (<span class="vhdlchar">oserdes_dqs_buf</span>),</div>
<div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;       .<span class="vhdlchar">D1</span>  (<span class="vhdlchar">oserdes_dqs</span>[<span class="vhdllogic">0</span>]),</div>
<div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;       .<span class="vhdlchar">D2</span>  (<span class="vhdlchar">oserdes_dqs</span>[<span class="vhdllogic">1</span>]),</div>
<div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;       .<span class="vhdlchar">C</span>   (<span class="vhdlchar">oserdes_clk_delayed</span>),</div>
<div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;       .<span class="vhdlchar">R</span>   (<span class="vhdllogic">1&#39;b0</span>),</div>
<div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;       .<span class="vhdlchar">S</span>   (),</div>
<div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;       .<span class="vhdlchar">CE</span>  (<span class="vhdllogic">1&#39;b1</span>)</div>
<div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;   );</div>
<div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;</div>
<div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;   <span class="vhdlchar">ODDR</span></div>
<div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;     #(.<span class="vhdlchar">DDR_CLK_EDGE</span>  (<span class="vhdlchar">ODDR_CLK_EDGE</span>))</div>
<div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;     <span class="vhdlchar">oddr_dqsts</span> </div>
<div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;   (    .<span class="vhdlchar">Q</span>  (<span class="vhdlchar">oserdes_dqsts_buf</span>),</div>
<div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;        .<span class="vhdlchar">D1</span> (<span class="vhdlchar">oserdes_dqsts</span>[<span class="vhdllogic">0</span>]),</div>
<div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;        .<span class="vhdlchar">D2</span> (<span class="vhdlchar">oserdes_dqsts</span>[<span class="vhdllogic">0</span>]),</div>
<div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;        .<span class="vhdlchar">C</span>  (<span class="vhdlchar">oserdes_clk_delayed</span>),</div>
<div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;        .<span class="vhdlchar">R</span>  (),</div>
<div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;        .<span class="vhdlchar">S</span>  (<span class="vhdllogic">1&#39;b0</span>),</div>
<div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;        .<span class="vhdlchar">CE</span> (<span class="vhdllogic">1&#39;b1</span>)</div>
<div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;   );</div>
<div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;</div>
<div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160; <span class="vhdlkeyword">end</span> <span class="keyword">// sdr rate</span></div>
<div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160; <span class="vhdlkeyword">else</span> <span class="vhdlkeyword">begin</span>:<span class="vhdlchar">null_dqs</span> </div>
<div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160; <span class="vhdlkeyword">end</span> </div>
<div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;<span class="vhdlkeyword">endgenerate</span></div>
<div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;</div>
<div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;<span class="vhdlkeyword">endmodule</span>           <span class="keyword">// byte_group_io</span></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Sep 8 2021 11:22:40 for AMC13 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
